{% extends '@KaitekFramework/Backend/module.html.twig' %}
{% trans_default_domain (modulename) %}
{% block begin_javascript_fix %}
<script type="text/javascript">
    {% endblock begin_javascript_fix %}


    {% block begin_javascript %}
    {{ parent() }}
    {{ modulename }}Obj.prototype = {
        storeConfig:{
            //Jobrotation:{routeName:'JobRotation-getComboValues',table:'job_rotations'}
            //,JobRotationTeam:{routeName:'JobRotationTeam-getComboValues',table:'job_rotation_teams'}
        },
        init : function(){
            var t = this;
            t.gridLoaded=false;
            {{ modulename }}Obj.superclass.init.call(t);
            t.win.maximize();
            t.windowButtons.add=false;
            t.windowButtons.edit=false;
            t.windowButtons.delete=false;
            t.windowButtons.formCancel=false;
            
            t.stores.viewoptions=new mj.store({
                data:[{id:'total',code:"{{ 'Reports.view_total'|trans }}"}
                    ,{id:'list',code:"{{ 'Reports.view_list'|trans }}"}
                ]
            });
            t.checks = {};
	        t.stationData = {};
            const formConfig= {
                items: [
                    new mj.form.fieldSet({
                        id : 'f1',
                        title : '&nbsp;',
                        labelWidth : '110px',
                        width : 170,
                        height : 260
                    }),
                    new mj.form.fieldSet({
                        id : 'f2',
                        title : '&nbsp;',
                        labelWidth : '110px',
                        width : 300,
                        height : 260,
                        style : 'position:absolute;top:0px;left:210px;',
                        items : [
                            new mj.form.field({
                                dataIndex: 'id',
                                hidden: true
                            }),
                            new mj.form.field({
                                dataIndex: 'version',
                                hidden: true
                            }),
                            new mj.form.dateField({
                                title : "{{ 'Reports.start'|trans }}",
                                labelWidth : '110px',
                                dataIndex : 'start',
                                width : 80,
                                notEmpty : true
                            }),
                            new mj.form.dateField({
                                title : "{{ 'Reports.finish'|trans }}",
                                labelWidth : '110px',
                                dataIndex : 'finish',
                                width : 80,
                                notEmpty : true
                            }),
                            new mj.form.combo({
                                title: "{{ 'Reports.jobrotation'|trans }}",
                                placeHolder: "{{ 'Reports.jobrotation_placeholder'|trans }}",
                                dataIndex: 'jobrotation',
                                labelWidth : '110px',
                                mode: 'local',
                                clearOnTriggerClick: true,
                                notEmpty: true,
                                grid: 's12 m6',
                                width: 170,
                                store: t.extras.job_rotations
                            }),
                            new mj.form.combo({
                                title: "{{ 'Reports.jobrotationteam'|trans }}",
                                placeHolder: "{{ 'Reports.jobrotationteam_placeholder'|trans }}",
                                dataIndex: 'jobrotationteam',
                                mode: 'local',
                                clearOnTriggerClick: true,
                                labelWidth : '110px',
                                grid: 's6 m4',
                                width: 170,
                                store: t.extras.job_rotation_teams
                            })//,
                            //new mj.form.combo({
                            //    title: "{{ 'Reports.viewoptions'|trans }}",
                            //    placeHolder: "{{ 'Reports.viewoptions_placeholder'|trans }}",
                            //    dataIndex: 'viewoption',
                            //    mode: 'local',
                            //    clearOnTriggerClick: true,
                            //    sameValueDisplay:false,
                            //    labelWidth : '110px',
                            //    grid: 's6 m4',
                            //    width: 170,
                            //    store: t.stores.viewoptions
                            //})
                        ]
                    })
                ]
            };

            t._setFormConfig(formConfig,t.initFormElementsEvents);
            t.forms.main.buttons[0].icon.removeClass('mj-save');
            t.forms.main.buttons[0].icon.addClass('mj-list');
            t.buttons.selectNone = t.forms.main.addButton({
                alt: "{{ 'Reports.selectNone'|trans }}",
                cls: 'btn-sm left',
                iconCls: 'mj-checkbox',
                scope: t,
                handler: function(){
                    t.checker(0);
                }
            });
            t.buttons.selectAll = t.forms.main.addButton({
                alt: "{{ 'Reports.selectAll'|trans }}",
                cls: 'btn-sm left',
                iconCls: 'mj-checkbox-checked',
                scope: t,
                handler: function(){
                    t.checker(1);
                }
            });

            t.len=t.forms.main.items.length;
            
            for(var i = 0,l = t.extras.clients.length;i<l;i++){
                if(t.forms.main.items.getIndex('id','client_' + t.extras.clients[i].code) === -1){
                    t.forms.main.add(
                        new mj.form.checkBox({
                            title : t.extras.clients[i].code,
                            id : 'client_' + t.extras.clients[i].code,
                            labelWidth : '130px',
                            labelPos : 'right',
                            dataIndex : 'client'/*,
                            checked : st.data[i].checked*/
                        }),'f1'
                    );
                }
            }
            t.checks.client = t.forms.main.items[0].items;
            t.tabPanels.main.setActive(0);
            t.panelChart=new mj.panel({
                renderTo : t.tabs.main.grid.getBody(),
                border : false,
                buttonPos:'bottom',
                buttons:[
                    {
                        alt: mj.lng.glb.filter,
                        cls: 'btn-sm left',
                        iconCls: 'mj-filter',
                        //invisible: true,
                        scope: t,
                        handler: function(a,b,c){
                            t.activateTabForm();
                        }
                    },
                    {
                        alt: mj.lng.glb.saveAsXLS,
                        cls: 'btn-sm left',
                        iconCls: 'mj-save-as-xls',
                        scope: t,
                        disabled: true,
                        handler: t._onButtonSaveAsXLSClick
                    }
                ] 
            });
            t.cntLostDetails=mj.NE(t.panelChart.getBody(),{style:'width: 100%;height: 100%;min-height: 600px;float: left;'});
        },
        checker : function(v){
            var t=this;
            var bi = t.forms.main.items[0].items;
            for(var i=0;i<bi.length;i++){
                bi[i].setValue(v);
            }
        },
        editSelectedRecord: function(){
            return;
        },
        save: function() {
            var t = this,
                _f = this.forms,
                f = this.forms.main;
            t.trigger('beforesave');
            if (f.modulename && typeof Routing !== 'undefined') {
                //if (f.validate()) {
                    var clients="";
                    var flag=false;
                    for(var i = 0 , l = t.checks.client.length;i<l;i++){
                        if(t.checks.client[i].checked){
                            flag=true;
                            id = t.checks.client[i].id.replace('client_','');
                            clients=(clients==""?id:clients+","+id);
                        }
                    }
                    if(flag){
                        t.waitMaskShow();
                        t.panelChart.buttons[1].setDisable();
                        var id = f.getValue('id').id;
                        var versionField = f.getField('version');
                        var version = typeof versionField != "undefined" ? f.getValue('version').version : 0;
                        var routeName = f.modulename + '-getReport';
                        var route = Routing.getRoute(routeName);
                        var url = Routing.generate(routeName);
                        var data = f.getValue();
                        data.clients=clients;
                        data.menuId = t.id;
                        data.reportname = t.reportname;
                        if (route && route.methods && route.methods.length>0 && route.methods[0]) {
                            $(t.cntLostDetails).empty();
                            if(t.chart_lost_details){
                                t.chart_lost_details.destroy();
                            }
                            $.ajax({
                                url: url,
                                method: "POST",
                                headers: { 
                                    "Content-Type": "application/json",
                                    "X-HTTP-Method-Override": route.methods[0] 
                                },
                                data: JSON.stringify(data),
                                dataType: 'json',
                                success: function(data, textStatus, xhr) {
                                    t.activateTabGrid();
                                    t.waitMaskHide();
                                    if(textStatus==='success'){
                                        //console.log(data);
                                        t.__data__=data;
                                        t.panelChart.buttons[1].setEnable();
                                        var d_cld=data.client_lost_details;
                                        var _cld_cat=[];
                                        var _cld_data=[];
                                        var _cld_data_adet=[];
                                        for(var i=0;i<d_cld.length;i++){
                                            _cld_cat.push(d_cld[i].losttype);
                                            _cld_data.push(parseFloat(d_cld[i].suredk));
                                            _cld_data_adet.push(parseInt(d_cld[i].sayi));
                                        }
                                        var options_lost_details = {
                                            chart: {
                                                height: 600,
                                                type: 'bar',
                                                toolbar:{
                                                    show:false
                                                }
                                            },
                                            plotOptions: {
                                                bar: {
                                                    dataLabels: {
                                                        position: 'top', // top, center, bottom
                                                    },
                                                }
                                            },
                                            dataLabels: {
                                                enabled: true,
                                                formatter: function (val) {
                                                    return val;
                                                },
                                                offsetY: -20,
                                                style: {
                                                    fontSize: '12px',
                                                    colors: ["#304758"]
                                                }
                                            },
                                            series: [{
                                                name: 'Kayıp Süresi',
                                                type: 'column',
                                                data: _cld_data
                                            },{
                                                name: 'Kayıp Adedi',
                                                type: 'column',
                                                data: _cld_data_adet
                                            }],
                                            xaxis: {
                                                categories: _cld_cat
                                            },
                                            yaxis: [{
                                                seriesName: 'süre',
                                                axisBorder: {
                                                    show: true
                                                },
                                                axisTicks: {
                                                    show: true
                                                },
                                                labels: {
                                                    show: true,
                                                    formatter: function (val) {
                                                        return val ;
                                                    }
                                                },
                                                title: {
                                                    text: "Kayıp Süre (dk)",
                                                    style: {
                                                        color: '#008ffb'
                                                    }
                                                }
                                            },
                                            {
                                                seriesName: 'adet',
                                                opposite: true,
                                                axisTicks: {
                                                    show: true
                                                },
                                                axisBorder: {
                                                    show: true
                                                },
                                                labels: {
                                                    //style: {
                                                    //    color: '#00E396'
                                                    //},
                                                    show: true,
                                                    formatter: function (val) {
                                                        return val ;
                                                    }
                                                },
                                                title: {
                                                    text: "Kayıp Adedi",
                                                    style: {
                                                        color: '#00E396'
                                                    }
                                                }
                                            }],
                                            title: {
                                                text: 'Kayıp Süreler (dk)',
                                                align: 'center',
                                                style: {
                                                    color: '#444'
                                                }
                                            }
                                        };

                                        t.chart_lost_details = new ApexCharts(
                                            t.cntLostDetails,
                                            options_lost_details
                                        );

                                        t.chart_lost_details.render();
                                    }
                                },
                                error: function(xhr, textStatus, errorThrown) {
                                    t.waitMaskHide();
                                    if(xhr.responseJSON&&xhr.responseJSON.message){
                                        mj.message({
                                            title: mj.lng.glb.error,
                                            msg: xhr.responseJSON.message,
                                            type: "error",
                                            html: true
                                        });
                                    }
                                },
                                complete: function(jqXHR, textStatus) {
                                    t.waitMaskHide();
                                }
                            });
                        }
                    }else{
                        t.messageShow(t,mj.lng.glb.error,mj.lng.glb.formSaveWarning);
                    }
                //}
            }
        }
    };
    {% endblock begin_javascript %}



    {% block begin_default_module %}
    {{ parent() }}
    {% endblock begin_default_module %}



    {% block end_default_module %}
    {{ parent() }}
    {% endblock end_default_module %}


    {% block end_javascript %}
    {{ parent() }}
    {% endblock end_javascript %}


    {% block end_javascript_fix %}
</script>
{% endblock end_javascript_fix %}



{% block body %}
    {{ parent() }}
{% endblock body %}
